#include "testlib.h"
#include <iostream>
#include <random>

using namespace std;

#define pb push_back
#define all(a) a.begin(), a.end()
#define sz(a) int(a.size())

typedef long long ll;
typedef pair<int, int> pii;

int main(int argc, char* argv[]) {
    registerGen(argc, argv, 1);
    int n, m;
    n = atoi(argv[1]);
    m = atoi(argv[2]);

    cout << n << ' ' << m << '\n';

    int B = sqrt(n);

    vector<int> a(n);
    vector<int> val((n + B - 1) / B);
    for (int i = 0; i < val.size(); ++i)
    	val[i] = rnd.next(1, m);
    shuffle(val.begin(), val.end(), mt19937(rnd.next(0, 1000000000)));
    for (int i = 0; i < n; ++i)
    	a[i] = val[i / B];

    for (int i = 0; i < n; ++i) {
    	cout << a[i];
    	if (i < n - 1) cout << ' ';
    }
    cout << '\n';
    for (int i = 0; i < n; ++i) {
    	cout << rnd.next(0, 5000);
    	if (i < n - 1) cout << ' ';
    }
    cout << '\n';
    for (int i = 0; i < n + m; ++i) {
    	cout << rnd.next(-5000, 5000);
    	if (i < n + m - 1) cout << ' ';
    }
    cout << '\n';
    return 0;
}
