#ifndef BZ
#pragma GCC optimize "-O3"
#endif
#include <bits/stdc++.h>

#define ALL(v) (v).begin(), (v).end()
#define rep(i, l, r) for (int i = (l); i < (r); ++i)

using ll = long long;
using ld = long double;
using ull = unsigned long long;

using namespace std;


/*
ll pw(ll a, ll b) {
	ll ans = 1; while (b) {
		while (!(b & 1)) b >>= 1, a = (a * a) % MOD;
		ans = (ans * a) % MOD, --b;
	} return ans;
}
*/

const int N = 4100;

int l[N];
int s[N];
int c[N];

int n, m;

int main() {
	ios_base::sync_with_stdio(false), cin.tie(0), cout.tie(0);
	cout.setf(ios::fixed), cout.precision(20);
	cin >> n >> m;
	for (int i = 0; i < n; ++i) {
		cin >> l[i];
	}
	for (int i = 0; i < n; ++i) {
		cin >> s[i];
	}
	for (int i = 1; i <= n + m; ++i) {
		cin >> c[i];
	}

	int ans = 0;
	for (int i = 0; i < (1 << n); ++i) {
		int pr = N;
		bool bad = false;
		int profit = 0;
		for (int j = 0; j < n; ++j) {
			if ((i >> j) & 1) {
				if (l[j] > pr) {
					bad = true;
					break;
				}
				pr = l[j];
				profit -= s[j];
			}
		}
		if (bad) {
			continue;
		}
		vector<int> vv;
		for (int j = 0; j < n; ++j) {
			if ((i >> j) & 1) {
				int cur = l[j];
				profit += c[cur];
				while (!vv.empty() && vv.back() == cur) {
					vv.pop_back();
					++cur;
					profit += c[cur];
				}
				vv.push_back(cur);
			}
		}
		ans = max(ans, profit);
	}
	cout << ans << "\n";
	return 0;
}


